unit FINEDemoExUnit1;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, CommDlg,
  Dialogs, ExtCtrls, Menus, ExtDlgs, ComCtrls, StdCtrls, CheckLst, Fine;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    Image2: TMenuItem;
    FlipHorizontal1: TMenuItem;
    FlipVertical1: TMenuItem;
    Rotate1: TMenuItem;
    OpenPictureDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    N1: TMenuItem;
    N2: TMenuItem;
    Convert1: TMenuItem;
    ResizeToWindow: TCheckBox;
    ResizeMethod: TComboBox;
    Label1: TLabel;
    RGB321: TMenuItem;
    RGB241: TMenuItem;
    RGB5551: TMenuItem;
    RGB5651: TMenuItem;
    RGB81: TMenuItem;
    Dithering1: TMenuItem;
    None1: TMenuItem;
    Ordered1: TMenuItem;
    FloydSteinberg1: TMenuItem;
    Benchmark1: TMenuItem;
    ResizeBenchmark1: TMenuItem;
    RotateBenchmark1: TMenuItem;
    FlipHorizontalBenchmark1: TMenuItem;
    FlipVerticalBenchmark1: TMenuItem;
    ConvertBenchmark1: TMenuItem;
    RotateCheckBox: TCheckBox;
    Degrees: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    RotationMethod: TComboBox;
    Label3: TLabel;
    RotationType: TComboBox;
    N3: TMenuItem;
    Resize1: TMenuItem;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Quantization1: TMenuItem;
    Nearest1: TMenuItem;
    Halftone1: TMenuItem;
    DitheredNearest1: TMenuItem;
    DitheredHalftone1: TMenuItem;
    FastDitheredNearest1: TMenuItem;
    FastDitheredHalftone1: TMenuItem;
    None2: TMenuItem;
    RGB8Bitmap1: TMenuItem;
    RGB555Bitmap1: TMenuItem;
    RGB565Bitmap1: TMenuItem;
    RGB32Bitmap1: TMenuItem;
    ARGB32Bitmap1: TMenuItem;
    UYVYRawImage1: TMenuItem;
    YUY2RawImage1: TMenuItem;
    UYVYRawImage2: TMenuItem;
    YVYURawImage1: TMenuItem;
    YV12RawImage1: TMenuItem;
    IYUVRawImage1: TMenuItem;
    RGB24Bitmap1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Panel2: TPanel;
    GroupBox9: TGroupBox;
    Label23: TLabel;
    FilterPower: TTrackBar;
    ResetFilterPower: TButton;
    ActiveFilters: TCheckListBox;
    FilterUp: TButton;
    FilterDown: TButton;
    PowerEdit: TEdit;
    Panel3: TPanel;
    Filter1: TMenuItem;
    N4: TMenuItem;
    ProgressBar1: TProgressBar;
    FilterBenchmark1: TMenuItem;
    N5: TMenuItem;
    Useoriginalbitmapforbenchmarking1: TMenuItem;
    ResizeAgain1: TMenuItem;
    NV121: TMenuItem;
    Architecture1: TMenuItem;
    UseMMXCalculations1: TMenuItem;
    UseSSE2Calculations1: TMenuItem;
    GroupBox1: TGroupBox;
    CropLeftEdit: TEdit;
    CropLeft: TUpDown;
    CropTopEdit: TEdit;
    CropTop: TUpDown;
    CropRightEdit: TEdit;
    CropRight: TUpDown;
    CropBottomEdit: TEdit;
    CropBottom: TUpDown;
    CropImage: TCheckBox;
    Crop1: TMenuItem;
    N6: TMenuItem;
    GroupBox2: TGroupBox;
    UseRotationCenter: TCheckBox;
    CenterX: TEdit;
    UDCenterX: TUpDown;
    Label4: TLabel;
    Label5: TLabel;
    CenterY: TEdit;
    UDCenterY: TUpDown;
    FineGraphics1: TFineGraphics;
    FineGraphics2: TFineGraphics;
    CropBenchmark1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FlipVertical1Click(Sender: TObject);
    procedure FlipHorizontal1Click(Sender: TObject);
    procedure ResizeMethodChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Resize1Click(Sender: TObject);
    procedure ResizeToWindowClick(Sender: TObject);
    procedure RotateCheckBoxClick(Sender: TObject);
    procedure RotationMethodChange(Sender: TObject);
    procedure RotationTypeChange(Sender: TObject);
    procedure DegreesChange(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure None2Click(Sender: TObject);
    procedure RGB321Click(Sender: TObject);
    procedure RGB241Click(Sender: TObject);
    procedure RGB5651Click(Sender: TObject);
    procedure RGB5551Click(Sender: TObject);
    procedure RGB81Click(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure Ordered1Click(Sender: TObject);
    procedure FloydSteinberg1Click(Sender: TObject);
    procedure Nearest1Click(Sender: TObject);
    procedure Halftone1Click(Sender: TObject);
    procedure DitheredNearest1Click(Sender: TObject);
    procedure DitheredHalftone1Click(Sender: TObject);
    procedure FastDitheredNearest1Click(Sender: TObject);
    procedure FastDitheredHalftone1Click(Sender: TObject);
    procedure RGB8Bitmap1Click(Sender: TObject);
    procedure RGB565Bitmap1Click(Sender: TObject);
    procedure RGB32Bitmap1Click(Sender: TObject);
    procedure RGB24Bitmap1Click(Sender: TObject);
    procedure ARGB32Bitmap1Click(Sender: TObject);
    procedure UYVYRawImage2Click(Sender: TObject);
    procedure YUY2RawImage1Click(Sender: TObject);
    procedure YVYURawImage1Click(Sender: TObject);
    procedure YV12RawImage1Click(Sender: TObject);
    procedure IYUVRawImage1Click(Sender: TObject);
    procedure RGB555Bitmap1Click(Sender: TObject);
    procedure SaveDialog1TypeChange(Sender: TObject);
    procedure OpenPictureDialog1TypeChange(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ActiveFiltersClickCheck(Sender: TObject);
    procedure ActiveFiltersClick(Sender: TObject);
    procedure FilterPowerChange(Sender: TObject);
    procedure PowerEditChange(Sender: TObject);
    procedure Filter1Click(Sender: TObject);
    procedure FilterUpClick(Sender: TObject);
    procedure FilterDownClick(Sender: TObject);
    procedure ResetFilterPowerClick(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure FlipHorizontalBenchmark1Click(Sender: TObject);
    procedure FlipVerticalBenchmark1Click(Sender: TObject);
    procedure ResizeBenchmark1Click(Sender: TObject);
    procedure RotateBenchmark1Click(Sender: TObject);
    procedure ConvertBenchmark1Click(Sender: TObject);
    procedure FilterBenchmark1Click(Sender: TObject);
    procedure ResizeAgain1Click(Sender: TObject);
    procedure NV121Click(Sender: TObject);
    procedure Architecture1Click(Sender: TObject);
    procedure UseMMXCalculations1Click(Sender: TObject);
    procedure UseSSE2Calculations1Click(Sender: TObject);
    procedure CropTopEditChange(Sender: TObject);
    procedure CropLeftEditChange(Sender: TObject);
    procedure CropBottomEditChange(Sender: TObject);
    procedure CropRightEditChange(Sender: TObject);
    procedure CropImageClick(Sender: TObject);
    procedure Crop1Click(Sender: TObject);
    procedure UseRotationCenterClick(Sender: TObject);
    procedure CenterXChange(Sender: TObject);
    procedure CenterYChange(Sender: TObject);
    procedure CropBenchmark1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Crop_Left              : Integer;
    Crop_Right             : Integer;
    Crop_Top               : Integer;
    Crop_Bottom            : Integer;
    PCTime1                : Int64;
    PCTime2                : Int64;
    PCFreq                 : Int64;
    PCEnabled              : Boolean;
    ElapsedTime            : Integer;
    FineDLL                : THandle;
    OriginalImage          : TBitmap;
    WorkBitmap             : TBitmap;
    FineInited             : Boolean;
    InActiveFiltersClick   : Boolean;
    InFilterPowerChange    : Boolean;
    Procedure StartTimer;
    Procedure StopTimer;
    Procedure EnableMenu(Enable : Boolean);
    function  GetImageSize(Width, Height, BitCount: Integer): Integer;
    function  GetFileSize(FileName : String):Int64;
    function  HasCheckedFilters : Boolean;
    function  DoCrop(Bitmap : TBitmap; Left, Top, Right, Bottom : Integer) : Boolean;
    function  DoFilter(Bitmap : TBitmap) : Boolean;
    function  DoFlipHorizontal(Bitmap : TBitmap) : Boolean;
    Function  DoFlipVertical(Bitmap : TBitmap) : Boolean;
    Function  DoResize(Bitmap : TBitmap; NewWidth, NewHeight : Integer) : Boolean;
    Function  DoRotate(Bitmap : TBitmap) : Boolean;
    Function  DoConvertFromRGBToRGB(Bitmap : TBitmap) : Boolean;
    Procedure DoSaveImage(MediaSubtype : TGUID);
    Procedure ApplyTransformations(WatchingNo : Integer);
  end;

var
  Form1: TForm1;

implementation
Uses
  Math, FineDemoExUnit2;
{$R *.dfm}

Const
  WatchingNone            = 0;
  WatchingFlipHorizontal  = 1;
  WatchingFlipVertical    = 2;
  WatchingResize          = 3;
  WatchingRotate          = 4;
  WatchingConvertRGBtoRGB = 5;
  WatchingFilter          = 6;
  WatchingCrop            = 7;


procedure TForm1.StartTimer;
begin
  QueryPerformanceCounter(PCTime1);
end;

procedure TForm1.StopTimer;
begin
  If PCEnabled then
     Begin
       QueryPerformanceCounter(PCTime2);
       ElapsedTime      := ((PCTime2-PCTime1) * 1000000) div PCFreq;
       PCTime1          := PCTime2;
     End;
end;

procedure TForm1.EnableMenu(Enable: Boolean);
Var
  X : Integer;
begin
  For X := 0 To MainMenu1.Items.Count-1 do MainMenu1.Items[X].Enabled := Enable;
end;

function TForm1.GetImageSize(Width, Height, BitCount: Integer): Integer;
begin
   Result := DWord(DWord(Width) * DWord(BitCount)+31) AND (NOT 31) Div 8;
   Result := Result*Abs(Height);
end;

function TForm1.GetFileSize(FileName: String): Int64;
Var
  Dir : TSearchRec;
begin
  Result := FindFirst(FileName,faAnyFile,Dir);
  if (Result=0) Then
     Begin
       Result := (Int64(Dir.FindData.nFileSizeHigh) SHL 32) Or (Dir.FindData.nFileSizeLow);
     End
  Else
     Begin
       Result := 0;
     End;
end;

function TForm1.HasCheckedFilters : Boolean;
Var
  X : Integer;
Begin
  Result := False;
  For X := 0 To ActiveFilters.Count-1 do
      Begin
        if ActiveFilters.Checked[X] Then
           Begin
             Result := True;
             Exit;
           End;
      End;
End;

function TForm1.DoFilter(Bitmap : TBitmap) : Boolean;
begin
  Result := False;
  if Bitmap.HandleAllocated Then
     Begin
       Try
         FineGraphics1.Source            := Bitmap;
         FineGraphics1.Target            := Nil;
         StartTimer;
         FineGraphics1.DoFilter          := True;
         StopTimer;
         Result                          := True;
       Finally
         FineGraphics1.Source            := Nil;
         FineGraphics1.Target            := Nil;
         FineGraphics1.DoFilter          := False;
       End;
     End;
end;

function TForm1.DoCrop(Bitmap : TBitmap; Left, Top, Right, Bottom : Integer) : Boolean;
begin
  if Bitmap.HandleAllocated Then
     Begin
       Try
         FineGraphics1.Source            := Bitmap;
         FineGraphics1.Target            := Nil;
         FineGraphics1.CropRect          := Rect(Left, Top, Right, Bottom);
         StartTimer;
         FineGraphics1.DoCrop            := True;
         StopTimer;
       Finally
         FineGraphics1.Source            := Nil;
         FineGraphics1.Target            := Nil;
         FineGraphics1.DoCrop            := False;
       End;
     End;
end;

function TForm1.DoFlipHorizontal(Bitmap : TBitmap): Boolean;
begin
  Result := False;
  if Bitmap.HandleAllocated Then
     Begin
       Try
         FineGraphics1.Source            := Bitmap;
         FineGraphics1.Target            := Nil; 
         StartTimer;
         FineGraphics1.DoFlipHorizontal  := True;
         StopTimer;
         Result                          := True;
       Finally
         FineGraphics1.Source            := Nil;
         FineGraphics1.Target            := Nil;
         FineGraphics1.DoFlipHorizontal  := False;
       End;
     End;
end;

function TForm1.DoFlipVertical(Bitmap : TBitmap): Boolean;
begin
  Result := False;
  if Bitmap.HandleAllocated Then
     Begin
       Try
         FineGraphics1.Source            := Bitmap;
         FineGraphics1.Target            := Nil; 
         StartTimer;
         FineGraphics1.DoFlipVertical    := True;
         StopTimer;
         Result                          := True;
       Finally
         FineGraphics1.Source            := Nil;
         FineGraphics1.Target            := Nil;
         FineGraphics1.DoFlipVertical    := False;
       End;
     End;
end;

function TForm1.DoResize(Bitmap : TBitmap; NewWidth, NewHeight : Integer) : Boolean;
begin
  Result := False;
  if Bitmap.HandleAllocated Then
     Begin                                                             
       Try
         FineGraphics1.Source            := Bitmap;
         FineGraphics1.Target            := Nil;
         FineGraphics1.SourceRect        := Rect(0,0,Bitmap.Width,Bitmap.Height);
         FineGraphics1.TargetRect        := Rect(0,0,NewWidth,Newheight);
         FineGraphics1.ResizeMethod      := TResizeMethod(ResizeMethod.ItemIndex);
         StartTimer;
         FineGraphics1.DoResize          := True;
         StopTimer;
         Result                          := True;
       Finally
         FineGraphics1.Source            := Nil;
         FineGraphics1.Target            := Nil;
         FineGraphics1.DoResize          := False;
       End;
     End;
end;

Function TForm1.DoRotate(Bitmap : TBitmap) : Boolean;
Var
  Angle     : Double;
begin
  Result := False;
  if Bitmap.HandleAllocated Then
     Begin
       Try
         FineGraphics1.Source            := Bitmap;
         FineGraphics1.Target            := Nil;
         if NOT TryStrToFloat(Degrees.Text,Angle) Then Angle := 0;
         if UseRotationCenter.Checked Then
            Begin
              FineGraphics1.RotationCenter := Point(UDCenterX.Position,UDCenterY.Position);
            End
         Else
            Begin
              FineGraphics1.RotationCenter := Point(Bitmap.Width Div 2,Bitmap.Height Div 2);
            End;
         FineGraphics1.RotationGapColor := clBlack;
         FineGraphics1.RotationAngle    := Angle;
         FineGraphics1.RotationMethod   := TRotationMethod(RotationMethod.ItemIndex);
         FineGraphics1.RotationType     := TRotationType(RotationType.ItemIndex);
         StartTimer;
         FineGraphics1.DoRotate          := True;
         StopTimer;
         Result                          := True;
       Finally
         FineGraphics1.Source            := Nil;
         FineGraphics1.Target            := Nil;
         FineGraphics1.DoRotate          := False;
       End;
     End;
end;

function TForm1.DoConvertFromRGBToRGB(Bitmap: TBitmap): Boolean;
Var
  BitmapHandle  : THandle;
  Dithering     : Integer;
  Quantization  : Integer;
begin
  Result := False;
  if Bitmap.HandleAllocated Then
     Begin
        Try
          //********************************************************************
          if RGB321.Checked                Then FineGraphics1.ConvertToRGB     := rcRGB32;
          if RGB241.Checked                Then FineGraphics1.ConvertToRGB     := rcRGB24;
          if RGB5651.Checked               Then FineGraphics1.ConvertToRGB     := rcRGB565;
          if RGB5551.Checked               Then FineGraphics1.ConvertToRGB     := rcRGB555;
          if RGB81.Checked                 Then FineGraphics1.ConvertToRGB     := rcRGB8;
          //********************************************************************
          FineGraphics1.DitheringType                                          := dtNone;
          FineGraphics1.QuantizationType                                       := qtDitheredHalftone;
          //********************************************************************
          if None1.Checked                 Then FineGraphics1.DitheringType    := dtNone;
          if Ordered1.Checked              Then FineGraphics1.DitheringType    := dtOrdered;
          if FloydSteinberg1.Checked       Then FineGraphics1.DitheringType    := dtFloydSteinberg;
          //********************************************************************
          if Nearest1.Checked              Then FineGraphics1.QuantizationType := qtNearest;
          if Halftone1.Checked             Then FineGraphics1.QuantizationType := qtHalftone;
          if DitheredNearest1.Checked      Then FineGraphics1.QuantizationType := qtDitheredNearest;
          if DitheredHalftone1.Checked     Then FineGraphics1.QuantizationType := qtDitheredHalftone;
          if FastDitheredNearest1.Checked  Then FineGraphics1.QuantizationType := qtFastDitheredNearest;
          if FastDitheredHalftone1.Checked Then FineGraphics1.QuantizationType := qtFastDitheredHalftone;
          //********************************************************************
          FineGraphics1.Source                                                 := Bitmap;
          FineGraphics1.Target                                                 := Nil;
          StartTimer;
          FineGraphics1.DoConvertToRGB                                         := True;
          StopTimer;
          Result                                                               := True;
          //********************************************************************
        Finally
          FineGraphics1.Source            := Nil;
          FineGraphics1.Target            := Nil;
          FineGraphics1.DoConvertToRGB    := False;
        End;
    End;
end;

procedure TForm1.DoSaveImage(MediaSubtype: TGUID);
Var
  SaveDim      : String;
  SaveRawData  : Boolean;
  FileName     : WideString;
  Bitmap       : TBitmap;
  Dithering    : Integer;
  Quantization : Integer;
begin
  Bitmap   := TBitmap.Create;
  Try
    if Image1.Picture.Bitmap.HandleAllocated Then
       Begin
          SaveDim    := ExtractFileName(OpenPictureDialog1.FileName)+'.'+IntToStr(Image1.Picture.Bitmap.Width)+'x'+IntToStr(Image1.Picture.Bitmap.Height);
          if FineGraphics2.CreateBitmap(Image1.Picture.Bitmap.Width,Image1.Picture.Bitmap.Height,Bitmap,MediaSubtype) Then
             Begin
               SaveRawData          := False;
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_RGB8)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.RGB8.bmp';
                    FineGraphics2.ConvertToSpace := ccRGB8;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_RGB555) Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.RGB555.bmp';
                    FineGraphics2.ConvertToSpace := ccRGB555;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_RGB565) Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.RGB565.bmp';
                    FineGraphics2.ConvertToSpace := ccRGB565;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_RGB24)  Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.RGB24.bmp';
                    FineGraphics2.ConvertToSpace := ccRGB24;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_RGB32)  Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.RGB32.bmp';
                    FineGraphics2.ConvertToSpace := ccRGB32;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_ARGB32) Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.ARGB32.bmp';
                    FineGraphics2.ConvertToSpace := ccARGB32;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_UYVY)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.UYVY.bmp';
                    FineGraphics2.ConvertToSpace := ccUYVY;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_YUY2)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.YUY2.bmp';
                    FineGraphics2.ConvertToSpace := ccYUY2;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_YVYU)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.YVYU.bmp';
                    FineGraphics2.ConvertToSpace := ccYVYU;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_YV12)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.YV12.bmp';
                    FineGraphics2.ConvertToSpace := ccYV12;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_IYUV)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.IYUV.bmp';
                    FineGraphics2.ConvertToSpace := ccIYUV;
                  End
               Else
               if IsEqualGUID(MediaSubtype,MEDIASUBTYPE_NV12)   Then
                  Begin
                    SaveDialog1.FileName         := SaveDim+'.NV12.bmp';
                    FineGraphics2.ConvertToSpace := ccNV12;
                  End;
               //********************************************************************
               FineGraphics2.DitheringType                                             := dtNone;
               FineGraphics2.QuantizationType                                          := qtDitheredHalftone;
               //********************************************************************
               if None1.Checked                 Then FineGraphics2.DitheringType       := dtNone;
               if Ordered1.Checked              Then FineGraphics2.DitheringType       := dtOrdered;
               if FloydSteinberg1.Checked       Then FineGraphics2.DitheringType       := dtFloydSteinberg;
               //********************************************************************
               if Nearest1.Checked              Then FineGraphics2.QuantizationType    := qtNearest;
               if Halftone1.Checked             Then FineGraphics2.QuantizationType    := qtHalftone;
               if DitheredNearest1.Checked      Then FineGraphics2.QuantizationType    := qtDitheredNearest;
               if DitheredHalftone1.Checked     Then FineGraphics2.QuantizationType    := qtDitheredHalftone;
               if FastDitheredNearest1.Checked  Then FineGraphics2.QuantizationType    := qtFastDitheredNearest;
               if FastDitheredHalftone1.Checked Then FineGraphics2.QuantizationType    := qtFastDitheredHalftone;
               //********************************************************************
               WorkBitmap.Assign(Image1.Picture.Bitmap);
               WorkBitmap.PixelFormat             := pf32Bit;
               //***************************************************************
               FineGraphics2.ConvertFromSpace     := ccRGB32;
               FineGraphics2.Source               := WorkBitmap;
               FineGraphics2.Target               := Bitmap;
               Try
                 FineGraphics2.DoConvert          := True;
               Finally
                 FineGraphics2.Source             := Nil;
                 FineGraphics2.Target             := Nil;
                 FineGraphics2.DoConvert          := False;
               End;
               //***************************************************************
               SaveDialog1.FilterIndex            := 1;
               if SaveDialog1.Execute Then
                  Begin
                    SaveRawData := SaveDialog1.FilterIndex=2;
                    FileName    := SaveDialog1.FileName;
                    if SaveRawData Then
                       Begin
                         if NOT FineGraphics2.SaveRawImage(FileName, Bitmap, MediaSubtype) Then
                            Begin
                              MessageBox(Handle,'FINEGraphics.SaveRawImage failed!','Stop! Error occured!',MB_ICONEXCLAMATION or MB_OK);
                            End;
                       End
                    Else
                       Begin
                          if NOT FineGraphics2.SaveBitmap(FileName, Bitmap, MediaSubtype) Then
                             Begin
                               MessageBox(Handle,'FINEGraphics.SaveBitmap failed!','Stop! Error occured!',MB_ICONEXCLAMATION or MB_OK);
                             End;
                       End;
                  End;
             End
          Else
             Begin
               MessageBox(Handle,'FINEGraphics.CreateBitmap failed!','Stop! Error occured!',MB_ICONEXCLAMATION or MB_OK);
             End;
       End;
    Finally
      Bitmap.Free;
    End;
end;


Procedure TForm1.ApplyTransformations(WatchingNo : Integer);
Begin
  if OriginalImage.HandleAllocated Then
     Begin
       StatusBar1.Panels[1].Text := '';
       StatusBar1.Panels[2].Text := '';
       StatusBar1.Panels[3].Text := '';
       WorkBitmap.Assign(OriginalImage);
       if (Filter1.Checked) And (HasCheckedFilters) Then
          Begin
            if WatchingNo=WatchingFilter Then StatusBar1.Panels[1].Text := ' Last Action: Filter Image ';
            DoFilter(WorkBitmap);
            if WatchingNo=WatchingFilter Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
            if WatchingNo=WatchingFilter Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
          End;
       if Crop1.Checked Then
          Begin
            if (Crop_Left   <> 0)
            Or (Crop_Right  <> 0)
            Or (Crop_Top    <> 0)
            Or (Crop_Bottom <> 0) Then
               Begin
                  if WatchingNo=WatchingCrop Then StatusBar1.Panels[1].Text := ' Last Action: Crop';
                  DoCrop(WorkBitmap,Crop_Left,Crop_Top,Crop_Right,Crop_Bottom);
                  if WatchingNo=WatchingCrop Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
                  if WatchingNo=WatchingCrop Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
               End;
          End;
       if FlipHorizontal1.Checked Then
          Begin
            if WatchingNo=WatchingFlipHorizontal Then StatusBar1.Panels[1].Text := ' Last Action: Flip Horizontal ';
            DoFlipHorizontal(WorkBitmap);
            if WatchingNo=WatchingFlipHorizontal Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
            if WatchingNo=WatchingFlipHorizontal Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
          End;
       if FlipVertical1.Checked   Then
          Begin
             if WatchingNo=WatchingFlipVertical Then StatusBar1.Panels[1].Text := ' Last Action: Flip Vertical ';
             DoFlipVertical(WorkBitmap);
             if WatchingNo=WatchingFlipVertical Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
             if WatchingNo=WatchingFlipVertical Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
          End;
       if ResizeToWindow.Checked  Then
          Begin
            if WatchingNo=WatchingResize Then StatusBar1.Panels[1].Text := ' Last Action: Resize ';
            DoResize(WorkBitmap,ScrollBox1.Width,ScrollBox1.Height);
            if WatchingNo=WatchingResize Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
            if WatchingNo=WatchingResize Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
          End;      
       if RotateCheckBox.Checked Then
          Begin
            if WatchingNo=WatchingRotate Then StatusBar1.Panels[1].Text := ' Last Action: Rotate ';
            DoRotate(WorkBitmap);
            if WatchingNo=WatchingRotate Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
            if WatchingNo=WatchingRotate Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
          End;
        if Not None2.Checked Then
           Begin
            if WatchingNo=WatchingConvertRGBtoRGB Then StatusBar1.Panels[1].Text := ' Last Action: Convert RGB to RGB ';
            DoConvertFromRGBToRGB(WorkBitmap);
            if WatchingNo=WatchingConvertRGBtoRGB  Then StatusBar1.Panels[2].Text := ' Done in '+IntToStr(ElapsedTime)+' microseconds. ';
            if WatchingNo=WatchingConvertRGBtoRGB  Then StatusBar1.Panels[3].Text := ' Done in '+FloatToStr(RoundTo(ElapsedTime/1000,-2))+' milliseconds. ';
           End;
        Image1.Picture.Bitmap.Assign(WorkBitmap);
        ScrollBox1.HorzScrollBar.Position := 0;
        ScrollBox1.VertScrollBar.Position := 0;
        Image1.Top                        := 0;
        Image1.Left                       := 0;
        Image1.Width                      := Image1.Picture.Bitmap.Width;
        Image1.Height                     := Image1.Picture.Bitmap.Height;
        Image1.Update;
        if ResizeToWindow.Checked  Then
           StatusBar1.Panels[0].Text := ' '+ExtractFileName(OpenPictureDialog1.FileName)+': '+IntToStr(OriginalImage.Width)+'x'+IntToStr(OriginalImage.Height)+' --> '+IntToStr(Image1.Width)+'x'+IntToStr(Image1.Height)
        Else
           StatusBar1.Panels[0].Text := ' '+ExtractFileName(OpenPictureDialog1.FileName)+': '+IntToStr(OriginalImage.Width)+'x'+IntToStr(OriginalImage.Height);
        StatusBar1.Panels[0].Width := StatusBar1.Canvas.TextWidth('W'+StatusBar1.Panels[0].Text+'W');
        StatusBar1.Panels[1].Width := StatusBar1.Canvas.TextWidth('W'+StatusBar1.Panels[1].Text+'W');
        StatusBar1.Panels[2].Width := StatusBar1.Canvas.TextWidth('W'+StatusBar1.Panels[2].Text+'W');
        StatusBar1.Panels[3].Width := StatusBar1.Canvas.TextWidth('W'+StatusBar1.Panels[3].Text+'W');
        StatusBar1.Update;
     End;
End;


procedure TForm1.FormCreate(Sender: TObject);
Var
  X           : Integer;
  Filter      : PGUID;
  FilterIndex : Integer;
  Parameters  : TFilterParameters;
begin
  FineInited                      := False;
  ScrollBox1.DoubleBuffered       := True;
  InActiveFiltersClick            := False;
  InFilterPowerChange             := False;
  Crop_Left                       := 0;
  Crop_Right                      := 0;
  Crop_Top                        := 0;
  Crop_Bottom                     := 0;
  FineGraphics1.FineGraphicsDLL   := 'FINEGraphics.dll';
  FineGraphics1.Active            := True;
  FineGraphics2.FineGraphicsDLL   := 'FINEGraphics.dll';
  FineGraphics2.Active            := True;
  QueryPerformanceFrequency(PCFreq);
  PCEnabled                 := (PCFreq<>0);
  OriginalImage             := TBitmap.Create;
  WorkBitmap                := TBitmap.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  OriginalImage.Free;
  WorkBitmap.Free;
  if FineDLL <> 0 Then FreeLibrary(FineDLL);
end;

procedure TForm1.Open1Click(Sender: TObject);
Var
  FN           : WideString;
  Ext          : String;
  SrcFormat    : TGUID;
  DstFormat    : TGUID;
  DoLoad       : Boolean;
  OpenRaw      : Boolean;
  ImageWidth   : Integer;
  ImageHeight  : Integer;
  Dithering    : TDitheringType;
  Quantization : TQuantizationType;
begin
  If OpenPictureDialog1.Execute Then
     Begin
       //********************************************************************
       Dithering                         := dtNone;
       Quantization                      := qtDitheredHalftone;
       //********************************************************************
       if None1.Checked                 Then Dithering       := dtNone;
       if Ordered1.Checked              Then Dithering       := dtOrdered;
       if FloydSteinberg1.Checked       Then Dithering       := dtFloydSteinberg;
       //********************************************************************
       if Nearest1.Checked              Then Quantization    := qtNearest;
       if Halftone1.Checked             Then Quantization    := qtHalftone;
       if DitheredNearest1.Checked      Then Quantization    := qtDitheredNearest;
       if DitheredHalftone1.Checked     Then Quantization    := qtDitheredHalftone;
       if FastDitheredNearest1.Checked  Then Quantization    := qtFastDitheredNearest;
       if FastDitheredHalftone1.Checked Then Quantization    := qtFastDitheredHalftone;
       //********************************************************************
       FN                        := OpenPictureDialog1.FileName;
       Ext                       := AnsiLowerCase(ExtractFileExt(FN));
       DoLoad                    := False;
       OpenRaw                   := False;
       if (Ext='.raw') or (OpenPictureDialog1.FilterIndex=9) Then
          Begin
            OpenRawForm1.Expected.Color         := clRed;
            OpenRawForm1.FileSize.Color         := clInfoBK;
            OpenRawForm1.FileSize.Text          := IntToStr(GetFileSize(FN));
            OpenRawForm1.FileName.Text          := ExtractFileName(FN);
            OpenRawForm1.ImageFormatChange(OpenRawForm1.ImageFormat);
            OpenRawForm1.ShowModal;
            if OpenRawForm1.ModalResult=mrOK Then
               Begin
                 SrcFormat   := OpenRawForm1.Format;
                 DstFormat   := MEDIASUBTYPE_RGB32;
                 ImageWidth  := OpenRawForm1.ImageWidth;
                 ImageHeight := OpenRawForm1.ImageHeight;
                 DoLoad      := True;
                 OpenRaw     := True;
               End;
          End
       Else
          Begin
            DstFormat := MEDIASUBTYPE_RGB32;
            DoLoad    := True;
          End;
       if DoLoad Then
          Begin
             if OpenRaw Then
                Begin
                  if FineGraphics1.LoadRawImage(FN,OriginalImage,ImageWidth,ImageHeight,SrcFormat,DstFormat,Quantization,Dithering) Then
                     Begin
                     End
                  Else
                     Begin
                     End;
                End
             Else
                Begin
                  if FineGraphics1.LoadBitmap(FN,OriginalImage,DstFormat,qtNearest,dtNone) Then
                     Begin
                     End
                  Else
                     Begin
                     End;
                End;
             StatusBar1.Panels[1].Text := '';
             StatusBar1.Panels[2].Text := '';
             StatusBar1.Panels[3].Text := '';
             StatusBar1.Panels[4].Text := '';
             FlipHorizontal1.Checked   := False;
             FlipVertical1.Checked     := False;
             if ResizeToWindow.Checked Then
                Begin
                  ApplyTransformations(WatchingResize);
                End
             Else
                Begin
                  ApplyTransformations(WatchingNone);
                End;
          End;
     End;
end;

procedure TForm1.FlipVertical1Click(Sender: TObject);
begin
  ApplyTransformations(WatchingFlipVertical);
end;

procedure TForm1.FlipHorizontal1Click(Sender: TObject);
begin
  ApplyTransformations(WatchingFlipHorizontal);
end;

procedure TForm1.ResizeMethodChange(Sender: TObject);
begin
  ApplyTransformations(WatchingResize);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if Not Application.Terminated Then
     Begin
       if Panel1.Enabled Then
          Begin
            if ResizeToWindow.Checked Then
               ApplyTransformations(WatchingResize)
             Else
               ApplyTransformations(WatchingNone);
          End;
     End;
end;

procedure TForm1.Resize1Click(Sender: TObject);
begin
  ResizeToWindow.Checked := Resize1.Checked;
  if ResizeToWindow.Checked Then
     ApplyTransformations(WatchingResize)
  Else
     ApplyTransformations(WatchingNone);
end;

procedure TForm1.ResizeAgain1Click(Sender: TObject);
begin
  Resize1.Checked        := True;
  ResizeToWindow.Checked := Resize1.Checked;
  ApplyTransformations(WatchingResize)
end;

procedure TForm1.ResizeToWindowClick(Sender: TObject);
begin
  Resize1.Checked := ResizeToWindow.Checked;
  if ResizeToWindow.Checked Then
     ApplyTransformations(WatchingResize)
  Else
     ApplyTransformations(WatchingNone);
end;

procedure TForm1.RotateCheckBoxClick(Sender: TObject);
begin
  Rotate1.Checked := RotateCheckBox.Checked;
  if RotateCheckBox.Checked Then
     ApplyTransformations(WatchingRotate)
  Else
     ApplyTransformations(WatchingNone);
end;

procedure TForm1.RotationMethodChange(Sender: TObject);
begin
  ApplyTransformations(WatchingRotate)
end;

procedure TForm1.RotationTypeChange(Sender: TObject);
begin
  ApplyTransformations(WatchingRotate)
end;

procedure TForm1.DegreesChange(Sender: TObject);
Var
  Angle : Double;
begin
  if TryStrToFloat(Degrees.Text,Angle) Then
     Begin
       ApplyTransformations(WatchingRotate)
     End;
end;

procedure TForm1.Rotate1Click(Sender: TObject);
begin
  RotateCheckBox.Checked := Rotate1.Checked;
  if RotateCheckBox.Checked Then
     ApplyTransformations(WatchingRotate)
  Else
     ApplyTransformations(WatchingNone);
end;

procedure TForm1.Filter1Click(Sender: TObject);
begin
  if Filter1.Checked Then
     Begin
       ApplyTransformations(WatchingFilter)
     End
  Else
     Begin
       ApplyTransformations(WatchingNone);
     End
end;

procedure TForm1.None2Click(Sender: TObject);
begin
  None2.Checked := True;
  ApplyTransformations(WatchingNone);
end;

procedure TForm1.RGB321Click(Sender: TObject);
begin
  RGB321.Checked := True;
  ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.RGB241Click(Sender: TObject);
begin
  RGB241.Checked := True;
  ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.RGB5651Click(Sender: TObject);
begin
  RGB5651.Checked := True;
  ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.RGB5551Click(Sender: TObject);
begin
  RGB5551.Checked := True;
  ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.RGB81Click(Sender: TObject);
begin
  RGB81.Checked := True;
  ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.None1Click(Sender: TObject);
begin
  None1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.Ordered1Click(Sender: TObject);
begin
  Ordered1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.FloydSteinberg1Click(Sender: TObject);
begin
  FloydSteinberg1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.Nearest1Click(Sender: TObject);
begin
  FloydSteinberg1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.Halftone1Click(Sender: TObject);
begin
  Halftone1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.DitheredNearest1Click(Sender: TObject);
begin
  DitheredNearest1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.DitheredHalftone1Click(Sender: TObject);
begin
  DitheredHalftone1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.FastDitheredNearest1Click(Sender: TObject);
begin
  FastDitheredNearest1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.FastDitheredHalftone1Click(Sender: TObject);
begin
  FastDitheredHalftone1.Checked := True;
  if NOT None2.Checked Then ApplyTransformations(WatchingConvertRGBtoRGB);
end;

procedure TForm1.RGB8Bitmap1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_RGB8);
end;

procedure TForm1.RGB555Bitmap1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_RGB555);
end;

procedure TForm1.RGB565Bitmap1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_RGB565);
end;

procedure TForm1.RGB24Bitmap1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_RGB24);
end;

procedure TForm1.RGB32Bitmap1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_RGB32);
end;

procedure TForm1.ARGB32Bitmap1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_ARGB32);
end;

procedure TForm1.UYVYRawImage2Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_UYVY);
end;

procedure TForm1.YUY2RawImage1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_YUY2);
end;

procedure TForm1.YVYURawImage1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_YVYU);
end;

procedure TForm1.YV12RawImage1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_YV12);
end;

procedure TForm1.IYUVRawImage1Click(Sender: TObject);
begin
  DoSaveImage(MEDIASUBTYPE_IYUV);
end;

procedure TForm1.NV121Click(Sender: TObject);
begin
 DoSaveImage(MEDIASUBTYPE_NV12);
end;

procedure TForm1.SaveDialog1TypeChange(Sender: TObject);
Const
  CmbFN   =  $0480;
Var
  FileName : String;
begin
  if AnsiLowerCase(GetCurrentDir) <> AnsiLowerCase(SaveDialog1.FileName) Then
     Begin
        FileName := '';
        Case SaveDialog1.FilterIndex of
          1  : Begin
                 FileName := ChangeFileExt(SaveDialog1.FileName,'.bmp');
               End;
          2  : Begin
                 FileName := ChangeFileExt(SaveDialog1.FileName,'.raw');
               End;
        End;
        if FileName <> '' Then
           Begin
             SendMessage(Windows.GetParent(SaveDialog1.Handle),CDM_SETCONTROLTEXT,CmbFN,Integer(PChar(ExtractFileName(FileName))));
           End;
    End;
end;

procedure TForm1.OpenPictureDialog1TypeChange(Sender: TObject);
Const
  CmbFN   =  $0480;
Var
  FileName : String;
begin
  if AnsiLowerCase(GetCurrentDir) <> AnsiLowerCase(OpenPictureDialog1.FileName) Then
     Begin
        FileName := '';
        Case OpenPictureDialog1.FilterIndex of
          2  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.bmp');
               End;
          3  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.gif');
               End;
          4  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.jpeg');
               End;
          5  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.jpg');
               End;
          6  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.tiff');
               End;
          7  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.tif');
               End;
          8  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.png');
               End;
          9  : Begin
                 FileName := ChangeFileExt(OpenPictureDialog1.FileName,'.raw');
               End;
        End;
        if FileName <> '' Then
           Begin
             SendMessage(Windows.GetParent(OpenPictureDialog1.Handle),CDM_SETCONTROLTEXT,CmbFN,Integer(PChar(ExtractFileName(FileName))));
           End;
    End;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  if Image1.Picture.Bitmap.HandleAllocated Then
     Begin
       Image1.Picture.Bitmap.SaveToFile(OpenPictureDialog1.FileName);
     End;
end;

procedure TForm1.ActiveFiltersClickCheck(Sender: TObject);
Var
  I           : Integer;
  Parameters  : TFilterParameters;
begin
   I := ActiveFilters.ItemIndex;
   if I > -1 Then
      Begin
        if FineGraphics1.SetFilterActive(I,ActiveFilters.Checked[I]) Then
           Begin
              InActiveFiltersClick   := True;
              InFilterPowerChange    := True;
              Try
                if FineGraphics1.GetFilterConfig(I,Parameters) Then
                   Begin
                     FilterPower.Position := Parameters.LParams[0];
                     PowerEdit.Text       := IntToStr(FilterPower.Position);
                     ApplyTransformations(WatchingFilter);
                   End;
              Finally
                InActiveFiltersClick := False;
                InFilterPowerChange  := False;
              End;
           End;
      End;
end;

procedure TForm1.ActiveFiltersClick(Sender: TObject);
Var
  I           : Integer;
  Parameters  : TFilterParameters;
begin
   I := ActiveFilters.ItemIndex;
   if I > -1 Then
      Begin
        InActiveFiltersClick   := True;
        InFilterPowerChange    := True;
        Try
          if FineGraphics1.GetFilterConfig(I,Parameters) Then
             Begin
               FilterPower.Position := Parameters.LParams[0];
               PowerEdit.Text       := IntToStr(FilterPower.Position);
               ApplyTransformations(WatchingFilter);
             End;
        Finally
          InActiveFiltersClick := False;
          InFilterPowerChange  := False;
        End;
      End;
end;

procedure TForm1.FilterPowerChange(Sender: TObject);
Var
  I           : Integer;
  IsActtive   : Boolean;
  Parameters  : TFilterParameters;
begin
  if Not InActiveFiltersClick Then
     Begin
       InFilterPowerChange := True;
       Try
         I := ActiveFilters.ItemIndex;
         if I > -1 Then
            Begin
               if FineGraphics1.GetFilterConfig(I,Parameters) Then
                  Begin
                    Parameters.LParams[0] := FilterPower.Position;
                    if FineGraphics1.SetFilterConfig(I,Parameters) Then
                       Begin
                         PowerEdit.Text := IntToStr(FilterPower.Position);
                         PowerEdit.Update;
                         ApplyTransformations(WatchingFilter);
                       End;
                  End;
            End;
       Finally
         InFilterPowerChange := False;
       End;
     End;
end;

procedure TForm1.PowerEditChange(Sender: TObject);
var
  Power : Integer;
begin
  if Not InFilterPowerChange Then
     Begin
       if TryStrToInt(PowerEdit.Text,Power) Then
          Begin
            if (Power >= FilterPower.Min) And (Power <= FilterPower.Max) Then
               Begin
                 FilterPower.Position := Power;
                 ApplyTransformations(WatchingFilter);
               End;
          End;
     End;
end;

procedure TForm1.FilterUpClick(Sender: TObject);
Var
  I   : Integer;
  X   : Integer;
  Res : HResult;
begin
  I := ActiveFilters.ItemIndex;
  if I > 0 Then
     Begin
        if FineGraphics1.SetFilterOrder(I,I-1) Then
           Begin
             ActiveFilters.Items.Exchange(I,I-1);
             ApplyTransformations(WatchingFilter);
           End;
     End;
end;

procedure TForm1.FilterDownClick(Sender: TObject);
Var
  I   : Integer;
  X   : Integer;
  Res : HResult;
begin
  I := ActiveFilters.ItemIndex;
  if I < 0 Then Exit;
  if I > ActiveFilters.Count-2 Then Exit;
  if FineGraphics1.SetFilterOrder(I,I+1) Then
     Begin
       ActiveFilters.Items.Exchange(I,I+1);
       ApplyTransformations(WatchingFilter);
     End;
end;

procedure TForm1.ResetFilterPowerClick(Sender: TObject);
Var
  I          : Integer;
  X          : Integer;
  Res        : HResult;
  Parameters : TFilterParameters;
  Filter     : TGUID;
begin
  I := ActiveFilters.ItemIndex;
  if I > -1 Then
     Begin
       FineGraphics1.ResetFilterConfig(I);
       if FineGraphics1.GetFilterConfig(I,Parameters) Then
          Begin
            FilterPower.Position := Parameters.LParams[0];
          End;
     End;
end;

procedure TForm1.UpDown1ChangingEx(Sender: TObject;  var AllowChange: Boolean; NewValue: Smallint;  Direction: TUpDownDirection);
begin
  AllowChange := True;
  UpDown1.Associate.Update;
end;

procedure TForm1.FlipHorizontalBenchmark1Click(Sender: TObject);
Var
  X         : Integer;
  Bmp1      : TBitmap;
  Bmp2      : TBitmap;
  PassTime  : Double;
begin
   FlipHorizontal1.Checked := True;
   ApplyTransformations(WatchingFlipHorizontal);
   PassTime := 0;
   if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
   if WorkBitmap.HandleAllocated Then
     Begin
       Bmp1           := TBitmap.Create;
       Panel1.Enabled := False;
       Panel2.Enabled := False;
       EnableMenu(False);
       Try
         ProgressBar1.Visible  := True;
         Bmp1.Assign(WorkBitmap);
         Bmp1.PixelFormat          := pf32Bit;
         DoResize(Bmp1,1920,1080);
         For X := 1 To 1000 do
             Begin
               Bmp2 := TBitmap.Create;
               Try
                 Bmp2.Assign(Bmp1);
                 FineGraphics1.Source := Bmp2;
                 StartTimer;
                 FineGraphics1.FlipHorizontal;
                 StopTimer;
                 PassTime              := PassTime+ElapsedTime;
                 ProgressBar1.Position := X;
                 ProgressBar1.Update;
                 Application.ProcessMessages;
               Finally
                 FineGraphics1.Source           := Nil;
                 Bmp2.Free;
               End;
             End;
         PassTime              := RoundTo(PassTime/1000,-2);
         PassTime              := RoundTo(PassTime/1000,-2);
         if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
       Finally
         Bmp1.Free;
         ProgressBar1.Position := 0;
         ProgressBar1.Visible  := False;
         Panel1.Enabled        := True;
         Panel2.Enabled        := True;
         EnableMenu(True);
       End;
     End;
end;

procedure TForm1.FlipVerticalBenchmark1Click(Sender: TObject);
Var
  X         : Integer;
  Bmp1      : TBitmap;
  Bmp2      : TBitmap;
  PassTime  : Double;
begin
   FlipVertical1.Checked := True;
   ApplyTransformations(WatchingFlipVertical);
   PassTime := 0;
   if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
   if WorkBitmap.HandleAllocated Then
     Begin
       Bmp1           := TBitmap.Create;
       Panel1.Enabled := False;
       Panel2.Enabled := False;
       EnableMenu(False);
       Try
         ProgressBar1.Visible  := True;
         Bmp1.Assign(WorkBitmap);
         Bmp1.PixelFormat          := pf32Bit;
         DoResize(Bmp1,1920,1080);
         For X := 1 To 1000 do
             Begin
               Bmp2 := TBitmap.Create;
               Try
                 Bmp2.Assign(Bmp1);
                 FineGraphics1.Source := Bmp2;
                 StartTimer;
                 FineGraphics1.FlipVertical;
                 StopTimer;
                 PassTime              := PassTime+ElapsedTime;
                 ProgressBar1.Position := X;
                 ProgressBar1.Update;
                 Application.ProcessMessages;
               Finally
                 FineGraphics1.Source := Nil;
                 Bmp2.Free;
               End;
             End;
         PassTime              := RoundTo(PassTime/1000,-2);
         PassTime              := RoundTo(PassTime/1000,-2);
         if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
       Finally
         Bmp1.Free;
         ProgressBar1.Position := 0;
         ProgressBar1.Visible  := False;
         Panel1.Enabled        := True;
         Panel2.Enabled        := True;
         EnableMenu(True);
       End;
     End;
end;

procedure TForm1.ResizeBenchmark1Click(Sender: TObject);
Var
  X         : Integer;
  Bmp1      : TBitmap;
  Bmp2      : TBitmap;
  PassTime  : Double;
begin
   ResizeToWindow.Checked := True;
   PassTime               := 0;
   if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
   if WorkBitmap.HandleAllocated Then
     Begin
       Bmp1           := TBitmap.Create;
       Panel1.Enabled := False;
       Panel2.Enabled := False;
       EnableMenu(False);
       Try
         ProgressBar1.Visible  := True;
         Bmp1.Assign(WorkBitmap);
         Bmp1.PixelFormat           := pf32Bit;
         FineGraphics1.SourceRect   := Rect(0,0,Bmp1.Width,Bmp1.Height);
         FineGraphics1.TargetRect   := Rect(0,0,1920,1080);
         FineGraphics1.ResizeMethod := TResizeMethod(ResizeMethod.ItemIndex);
         FineGraphics1.PrepareResize(Bmp1.Width,Bmp1.Height);
         For X := 1 To 1000 do
             Begin
               Bmp2 := TBitmap.Create;
               Try
                 Bmp2.Assign(Bmp1);
                 FineGraphics1.Source := BMP1;
                 StartTimer;
                 FineGraphics1.Resize;
                 StopTimer;
                 PassTime              := PassTime+ElapsedTime;
                 ProgressBar1.Position := X;
                 ProgressBar1.Update;
                 Application.ProcessMessages;
               Finally
                 FineGraphics1.Source := Nil;
                 Bmp2.Free;
               End;
             End;
         FineGraphics1.SourceRect   := Rect(0,0,0,0);
         FineGraphics1.TargetRect   := Rect(0,0,0,0);
         PassTime              := RoundTo(PassTime/1000,-2);
         PassTime              := RoundTo(PassTime/1000,-2);
         if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
       Finally
         Bmp1.Free;
         ProgressBar1.Position := 0;
         ProgressBar1.Visible  := False;
         Panel1.Enabled        := True;
         Panel2.Enabled        := True;
         EnableMenu(True);
       End;
     End;
end;

procedure TForm1.RotateBenchmark1Click(Sender: TObject);
Var
  X         : Integer;
  Bmp1      : TBitmap;
  Bmp2      : TBitmap;
  PassTime  : Double;
  Angle     : Double;
begin
   RotateCheckBox.Checked := True;
   PassTime := 0;
   if NOT TryStrToFloat(Degrees.Text,Angle) Then Angle := 0;
   if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
   if WorkBitmap.HandleAllocated Then
     Begin
       Bmp1           := TBitmap.Create;
       Panel1.Enabled := False;
       Panel2.Enabled := False;
       EnableMenu(False);
       Try
         ProgressBar1.Visible            := True;
         Bmp1.Assign(WorkBitmap);
         Bmp1.PixelFormat                := pf32Bit;
         DoResize(Bmp1,1920,1080);
         if UseRotationCenter.Checked Then
            FineGraphics1.RotationCenter := Point(UDCenterX.Position,UDCenterY.Position)
         Else
            FineGraphics1.RotationCenter := Point(Bmp1.Width DIV 2,Bmp1.Height Div 2);
         FineGraphics1.RotationAngle     := Angle;
         FineGraphics1.RotationMethod    := TRotationMethod(RotationMethod.ItemIndex);
         FineGraphics1.RotationType      := TRotationType(RotationType.ItemIndex);
         FineGraphics1.RotationGapColor  := clBlack;
         FineGraphics1.PrepareRotate(Bmp1.Width,Bmp1.Height);
         For X := 1 To 1000 do
             Begin
               Bmp2 := TBitmap.Create;
               Try
                 Bmp2.Assign(Bmp1);
                 FineGraphics1.Source  := Bmp1;
                 StartTimer;
                 FineGraphics1.Rotate;
                 StopTimer;
                 PassTime              := PassTime+ElapsedTime;
                 ProgressBar1.Position := X;
                 ProgressBar1.Update;
                 Application.ProcessMessages;
               Finally
                 FineGraphics1.Source  := Nil;
                 Bmp2.Free;
               End;
             End;
         PassTime              := RoundTo(PassTime/1000,-2);
         PassTime              := RoundTo(PassTime/1000,-2);
         if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
       Finally
         Bmp1.Free;
         ProgressBar1.Position := 0;
         ProgressBar1.Visible  := False;
         Panel1.Enabled        := True;
         Panel2.Enabled        := True;
         EnableMenu(True);
       End;
     End;
end;

procedure TForm1.ConvertBenchmark1Click(Sender: TObject);
Var
  X            : Integer;
  Bmp1         : TBitmap;
  Bmp2         : TBitmap;
  BmpHandle    : THandle;
  PassTime     : Double;
begin
  PassTime := 0;
  if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
  if WorkBitmap.HandleAllocated Then
     Begin
        Bmp1           := TBitmap.Create;
        Panel1.Enabled := False;
        Panel2.Enabled := False;
        EnableMenu(False);
        Try
          ProgressBar1.Visible             := True;
          Bmp1.PixelFormat                 := pf32Bit;
          FineGraphics1.ConvertToRGB       := rcRGB32;
          if RGB321.Checked                Then Begin Bmp1.PixelFormat := pf32Bit; FineGraphics1.ConvertToRGB := rcRGB32;  End;
          if RGB241.Checked                Then Begin Bmp1.PixelFormat := pf24Bit; FineGraphics1.ConvertToRGB := rcRGB24;  End;
          if RGB5651.Checked               Then Begin Bmp1.PixelFormat := pf16Bit; FineGraphics1.ConvertToRGB := rcRGB555; End;
          if RGB5551.Checked               Then Begin Bmp1.PixelFormat := pf15Bit; FineGraphics1.ConvertToRGB := rcRGB565; End;
          if RGB81.Checked                 Then Begin Bmp1.PixelFormat := pf8Bit;  FineGraphics1.ConvertToRGB := rcRGB8;   End;
          //********************************************************************
          FineGraphics1.DitheringType      := dtNone;
          FineGraphics1.QuantizationType   := qtDitheredHalftone;
          //********************************************************************
          if None1.Checked                 Then FineGraphics1.DitheringType      := dtNone;
          if Ordered1.Checked              Then FineGraphics1.DitheringType      := dtOrdered;
          if FloydSteinberg1.Checked       Then FineGraphics1.DitheringType      := dtFloydSteinberg;
          //********************************************************************
          if Nearest1.Checked              Then FineGraphics1.QuantizationType   := qtNearest;
          if Halftone1.Checked             Then FineGraphics1.QuantizationType   := qtHalftone;
          if DitheredNearest1.Checked      Then FineGraphics1.QuantizationType   := qtDitheredNearest;
          if DitheredHalftone1.Checked     Then FineGraphics1.QuantizationType   := qtDitheredHalftone;
          if FastDitheredNearest1.Checked  Then FineGraphics1.QuantizationType   := qtFastDitheredNearest;
          if FastDitheredHalftone1.Checked Then FineGraphics1.QuantizationType   := qtFastDitheredHalftone;
          //********************************************************************
          WorkBitmap.PixelFormat                                := pf32Bit;
          DoResize(WorkBitmap,1920,1080);
          Bmp1.Width                                            := WorkBitmap.Width;
          Bmp1.Height                                           := WorkBitmap.Height;
          FineGraphics1.Source                                  := WorkBitmap;
          FineGraphics1.Target                                  := Bmp1;
          For X := 1 to 1000 do
              Begin
                StartTimer;
                FineGraphics1.DoConvertToRGB                    := True;
                StopTimer;
                PassTime                                        := PassTime+ElapsedTime;
                ProgressBar1.Position                           := X;
                ProgressBar1.Update;
                Application.ProcessMessages;
              End;
          FineGraphics1.DoConvertToRGB                          := False;    
          FineGraphics1.Source                                  := Nil;
          FineGraphics1.Target                                  := Nil;
          //********************************************************************
          PassTime              := RoundTo(PassTime/1000,-2);
          PassTime              := RoundTo(PassTime/1000,-2);
          if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
          WorkBitmap.Assign(OriginalImage);
        Finally
          Bmp1.Free;
          ProgressBar1.Position := 0;
          ProgressBar1.Visible  := False;
          Panel1.Enabled        := True;
          Panel2.Enabled        := True;
          EnableMenu(True);
        End;
    End;
end;

procedure TForm1.FilterBenchmark1Click(Sender: TObject);
Var
  X         : Integer;
  Bmp1      : TBitmap;
  Bmp2      : TBitmap;
  PassTime  : Double;
begin
   Filter1.Checked := True;
   ApplyTransformations(WatchingFilter);
   PassTime := 0;
   if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
   if WorkBitmap.HandleAllocated Then
     Begin
       Bmp1           := TBitmap.Create;
       Panel1.Enabled := False;
       Panel2.Enabled := False;
       EnableMenu(False);
       Try
         ProgressBar1.Visible  := True;
         Bmp1.Assign(WorkBitmap);
         Bmp1.PixelFormat          := pf32Bit;
         DoResize(Bmp1,1920,1080);
         For X := 1 To 1000 do
             Begin
               Bmp2 := TBitmap.Create;
               Try
                 Bmp2.Assign(Bmp1);
                 FineGraphics1.Source := Bmp2;
                 StartTimer;
                 FineGraphics1.Filter;
                 StopTimer;
                 PassTime              := PassTime+ElapsedTime;
                 ProgressBar1.Position := X;
                 ProgressBar1.Update;
                 Application.ProcessMessages;
               Finally
                 FineGraphics1.Source := Nil;
                 Bmp2.Free;
               End;
             End;
         PassTime              := RoundTo(PassTime/1000,-2);
         PassTime              := RoundTo(PassTime/1000,-2);
         if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
       Finally
         Bmp1.Free;
         ProgressBar1.Position := 0;
         ProgressBar1.Visible  := False;
         Panel1.Enabled        := True;
         Panel2.Enabled        := True;
         EnableMenu(True);
       End;
     End;
end;

procedure TForm1.CropBenchmark1Click(Sender: TObject);
Var
  X         : Integer;
  Bmp1      : TBitmap;
  Bmp2      : TBitmap;
  PassTime  : Double;
begin
   CropImage.Checked := True;
   ApplyTransformations(WatchingCrop);
   PassTime := 0;
   if Useoriginalbitmapforbenchmarking1.Checked Then
      WorkBitmap.Assign(OriginalImage)
   Else
      WorkBitmap.Assign(Image1.Picture.Bitmap);
   if WorkBitmap.HandleAllocated Then
     Begin
       Bmp1           := TBitmap.Create;
       Panel1.Enabled := False;
       Panel2.Enabled := False;
       EnableMenu(False);
       Try
         ProgressBar1.Visible  := True;
         Bmp1.Assign(WorkBitmap);
         Bmp1.PixelFormat          := pf32Bit;
         DoResize(Bmp1,1920,1080);
         FineGraphics1.CropRect    := Rect(Crop_Left,Crop_Top,Crop_Right,Crop_Bottom);
         FineGraphics1.PrepareCrop(Bmp1.Width,Bmp1.Height);
         For X := 1 To 1000 do
             Begin
               Bmp2 := TBitmap.Create;
               Try
                 Bmp2.Assign(Bmp1);
                 FineGraphics1.Source := Bmp2;
                 StartTimer;
                 FineGraphics1.Crop;
                 StopTimer;
                 PassTime              := PassTime+ElapsedTime;
                 ProgressBar1.Position := X;
                 ProgressBar1.Update;
                 Application.ProcessMessages;
               Finally
                 FineGraphics1.Source := Nil;
                 Bmp2.Free;
               End;
             End;
         FineGraphics1.DoneCrop;
         PassTime              := RoundTo(PassTime/1000,-2);
         PassTime              := RoundTo(PassTime/1000,-2);
         if PassTime <> 0 Then Panel3.Caption := FloatToStr(RoundTo(1000/PassTime,-2))+' frames per second.';
       Finally
         Bmp1.Free;
         ProgressBar1.Position := 0;
         ProgressBar1.Visible  := False;
         Panel1.Enabled        := True;
         Panel2.Enabled        := True;
         EnableMenu(True);
       End;
     End;
end;

procedure TForm1.Architecture1Click(Sender: TObject);
begin
  UseMMXCalculations1.Checked  := FineGraphics1.UseMMX;
  UseSSE2Calculations1.Checked := FineGraphics1.UseSSE2;
end;

procedure TForm1.UseMMXCalculations1Click(Sender: TObject);
begin
  FineGraphics1.UseMMX := UseMMXCalculations1.Checked
end;

procedure TForm1.UseSSE2Calculations1Click(Sender: TObject);
begin
  FineGraphics1.UseSSE2 := UseSSE2Calculations1.Checked;
end;

procedure TForm1.CropLeftEditChange(Sender: TObject);
Var
  Err   : Integer;
  Value : Integer;
begin
  Val(CropLeftEdit.Text,Value,Err);
  if Err=0 Then
     Begin
       Crop_Left := Value;
     End;
  if CropImage.Checked Then ApplyTransformations(WatchingCrop);
  CropLeftEdit.Update;
end;

procedure TForm1.CropTopEditChange(Sender: TObject);
Var
  Err   : Integer;
  Value : Integer;
begin
  Val(CropTopEdit.Text,Value,Err);
  if Err=0 Then
     Begin
       Crop_Top := Value;
     End;
  if CropImage.Checked Then ApplyTransformations(WatchingCrop);
  CropTopEdit.Update;
end;

procedure TForm1.CropBottomEditChange(Sender: TObject);
Var
  Err   : Integer;
  Value : Integer;
begin
  Val(CropBottomEdit.Text,Value,Err);
  if Err=0 Then
     Begin
       Crop_Bottom := Value;
     End;
  if CropImage.Checked Then ApplyTransformations(WatchingCrop);
  CropBottomEdit.Update;
end;

procedure TForm1.CropRightEditChange(Sender: TObject);
Var
  Err   : Integer;
  Value : Integer;
begin
  Val(CropRightEdit.Text,Value,Err);
  if Err=0 Then
     Begin
       Crop_Right := Value;
     End;
  if CropImage.Checked Then ApplyTransformations(WatchingCrop);
  CropRightEdit.Update;
end;

procedure TForm1.CropImageClick(Sender: TObject);
begin
  Crop1.Checked := CropImage.Checked;
  if CropImage.Checked Then
     ApplyTransformations(WatchingCrop)
  Else
     ApplyTransformations(WatchingNone);
end;

procedure TForm1.Crop1Click(Sender: TObject);
begin
  CropImage.Checked := Crop1.Checked;
  if CropImage.Checked Then
     ApplyTransformations(WatchingCrop)
  Else
     ApplyTransformations(WatchingNone);
end;

procedure TForm1.UseRotationCenterClick(Sender: TObject);
begin
  if RotateCheckBox.Checked Then ApplyTransformations(WatchingRotate);
end;

procedure TForm1.CenterXChange(Sender: TObject);
Var
  Err   : Integer;
  Value : Integer;
begin
  Val(CenterX.Text,Value,Err);
  if Err=0 Then
     Begin
       if RotateCheckBox.Checked Then ApplyTransformations(WatchingRotate);
       CenterX.Update;
     End;
end;

procedure TForm1.CenterYChange(Sender: TObject);
Var
  Err   : Integer;
  Value : Integer;
begin
  Val(CenterY.Text,Value,Err);
  if Err=0 Then
     Begin
       if RotateCheckBox.Checked Then ApplyTransformations(WatchingRotate);
       CenterY.Update;
     End;
end;



end.
